BezierCurvePoints = {}
finalpoints = {}

function Recursive_Bezier(tab ,procent)
	local points = tab

	FINALPOINT = nil
	newpoints = {}
	for i = 1,#points-1 do
		local p1 = points[i]
		local p2 = points[i+1]
		local xstep = (p2.x-p1.x)/100--100%
		local ystep = (p2.y-p1.y)/100
		table.insert(newpoints,{--return procent point
			x = p1.x+(xstep*procent),
			y = p1.y+(ystep*procent)
		})
	end
	if #newpoints > 1 then--WE NEED THAT FINAL POINT
		Recursive_Bezier(newpoints,procent)
	else--WE GOT IT FAGGOTS!
		FINALPOINT = newpoints[1]
	end

	return FINALPOINT
end


function Make_Bezier_Curve_Points(BPoints)
	local calculatedpoints = {BezierCurvePoints[1]}
	for proc = 1,100 do
		table.insert(calculatedpoints,Recursive_Bezier(BPoints,proc))
	end
	return calculatedpoints
end

function love.mousepressed( mx, my, button )
	if button == "l" then
		table.insert(BezierCurvePoints,{x = mx,y = my})
		finalpoints = Make_Bezier_Curve_Points(BezierCurvePoints)
	else
		finalpoints = {}
		BezierCurvePoints = {}
	end
end

function love.draw()
	for i = 1,#finalpoints-1 do
		love.graphics.setColor(255,0,0,125)
		local p1 = finalpoints[i]
		local p2 = finalpoints[i+1]
		love.graphics.line(p1.x,p1.y,p2.x,p2.y)
		love.graphics.setColor(0,0,255,125)
		love.graphics.circle("fill",p1.x,p1.y,2)
	end
	for i = 1,#BezierCurvePoints do
		p1 = BezierCurvePoints[i]
		p2 = BezierCurvePoints[i+1]
		love.graphics.setColor(255,255,255,125)
		if p2 then
			love.graphics.line(p1.x,p1.y,p2.x,p2.y)
		end
		love.graphics.setColor(0,255,0,125)
		love.graphics.circle("fill",p1.x,p1.y,5)
	end
end

finalpoints = Make_Bezier_Curve_Points(BezierCurvePoints)